/***************************************************************************
                          eliparctool.h  -  description
                             -------------------
    begin                : Thu Mar 27 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ELIPARCTOOL_H
#define ELIPARCTOOL_H

#include <toolbase.h>
#include <qpointarray.h>

class DrawInRepeat;  
class ElipArcTool : public ToolBase  {
  Q_OBJECT
public: 
	ElipArcTool(DrawInRepeat *drawp, ToolType type, PropObject *propObj);
	~ElipArcTool();

 virtual void mousePressed(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseReleased(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseMoved(QMouseEvent *e, QPainter *pc, QPainter *pi);
 void end();
 virtual void showCommonProp(bool enable);
   
private:

  int  drawElArc(int Px, int Py, int Qx, int Qy, int Kx, int Ky, QPointArray &epts);
  int  qtr_elips(long xP, long yP, long xQ, long yQ, long xK, long yK, long m, QPointArray &epts);
  void drawCross(int x, int y, QPainter *p);

  int pt, xr[3], yr[3];
  QPointArray pts;
  int numPts;
  bool drawStarted;
  ButtonState btnPressed;
  DrawInRepeat *draw;
};

#endif
