/***************************************************************************
                          zoomtool.h  -  description
                             -------------------
    begin                : Thu Oct 30 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ZOOMTOOL_H
#define ZOOMTOOL_H

#include <toolbase.h>

enum ZoomType{ZoomInType, ZoomOutType};
    
class ZoomTool : public ToolBase  {
   Q_OBJECT
public: 
	ZoomTool(ToolType ttyp, ZoomType ztyp);
	~ZoomTool();

   void doAction();

signals:
   void scaleUp(int x, int y, bool center);
   void scaleDown(int x, int y, bool center);
      
private:
  ZoomType type;  
};

#endif
